package chapter07;

import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Node;

public class MyDocumentFragment11 {

	public static void main(String[] args) {
		try {
			DocumentBuilderFactory docfactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder docbuilder = docfactory.newDocumentBuilder();
			Document mydoc = docbuilder.parse("documentFragment11.xml");

			DocumentFragment df = mydoc.createDocumentFragment();
			Node node = mydoc.createElement("xxx");
			node.appendChild(mydoc.createTextNode("111"));
			df.appendChild(node);
			df.appendChild(mydoc.createTextNode("222"));

			mydoc.getDocumentElement().appendChild(df);

			saveXML(mydoc, System.out);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static void saveXML(Document document, OutputStream out)
			throws Exception {
		TransformerFactory tff = TransformerFactory.newInstance();
		Transformer tf = tff.newTransformer();
		
		DOMSource domsrc = new DOMSource();
		domsrc.setNode(document);

		StreamResult target = new StreamResult();

		target.setOutputStream(out);
		tf.transform(domsrc, target);
	}
}