package chapter07;

import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import com.sun.org.apache.xerces.internal.dom.DOMImplementationImpl;

public class MyDocumentFragment12 {

	public static void main(String[] args) {
		try {
			DocumentBuilderFactory docfactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder docbuilder = docfactory.newDocumentBuilder();

			DOMImplementation impl = DOMImplementationImpl
					.getDOMImplementation();
			Document mydoc = impl.createDocument("", "root", null);
			Element documentElement = mydoc.getDocumentElement();

			DocumentFragment df = mydoc.createDocumentFragment();
			Node node = mydoc.createElement("xxx");
			node.appendChild(mydoc.createTextNode("111"));
			df.appendChild(node);
			df.appendChild(mydoc.createTextNode("222"));

			Document document1 = docbuilder.parse("documentFragment12a.xml");
			Node node1 = document1.importNode(df, true);
			document1.getDocumentElement().appendChild(node1);

			Document document2 = docbuilder.parse("DocumentFragment12b.xml");
			Node node2 = document2.importNode(df, true);
			document2.getDocumentElement().appendChild(node2);

			saveXML(document1, System.out);
			System.out.println("\n\n");
			saveXML(document2, System.out);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static void saveXML(Document document, OutputStream out)
			throws Exception {
		TransformerFactory tff = TransformerFactory.newInstance();
		Transformer tf = tff.newTransformer();

		DOMSource domsrc = new DOMSource();
		domsrc.setNode(document);

		StreamResult target = new StreamResult();

		target.setOutputStream(out);
		tf.transform(domsrc, target);
	}
}