package chapter07;

import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

public class MyDomTreeChange01 {

	public static void main(String[] args) {
		try {
			DocumentBuilderFactory docfactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder docbuilder = docfactory.newDocumentBuilder();
			Document document = docbuilder.parse("domTreeChange01.xml");

			Element documentElement = document.getDocumentElement();

			Element element = document.createElement("bbb");
			Text text = document.createTextNode("111");
			element.appendChild(text);
			documentElement.appendChild(element);

			NodeList nl = documentElement.getElementsByTagName("aaa");
			for (int i = 0; i < nl.getLength(); i++) {
				documentElement.removeChild(nl.item(i));
			}

			saveXML(document, System.out);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static void saveXML(Node node, OutputStream out) throws Exception {
		TransformerFactory tff = TransformerFactory.newInstance();
		Transformer tf = tff.newTransformer();

		DOMSource domsrc = new DOMSource();
		domsrc.setNode(node);

		StreamResult sr = new StreamResult(out);

		tf.transform(domsrc, sr);
	}
}