package chapter07;

import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class MyEntityRefer01 {

	public static void main(String[] args) {
		try {
			DocumentBuilderFactory docfactory = DocumentBuilderFactory
					.newInstance();
			docfactory.setValidating(true);
			docfactory.setExpandEntityReferences(false);
			DocumentBuilder docbuilder = docfactory.newDocumentBuilder();
			Document document = docbuilder.parse("entityrefer01.xml");

			Node docElement = document.getDocumentElement();
			
			System.out.println("***** saveXML *****");
			saveXML(document, System.out);
			
			System.out.println("\n\n");
			System.out.println("***** getAllNode *****");
			getAllNode(document, 0);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static void saveXML(Node node, OutputStream out) throws Exception {
		TransformerFactory tff = TransformerFactory.newInstance();
		Transformer tf = tff.newTransformer();

		DOMSource domsrc = new DOMSource();
		domsrc.setNode(node);

		StreamResult sr = new StreamResult(out);

		tf.transform(domsrc, sr);
	}
    public static void getAllNode(Node node, int depth) {
        depth++;
        printNode(node, depth);

        if (node.getNodeType() == Node.ELEMENT_NODE) {
            NamedNodeMap nnm = node.getAttributes();
            for (int i = 0; i < nnm.getLength(); i++) {
                printNode(nnm.item(i), depth);
            }
        }

        NodeList nl = node.getChildNodes();
        for (int i = 0; i < nl.getLength(); i++) {
            Node childnode = nl.item(i);
            getAllNode(childnode, depth);
        }
    }

    public static void printNode(Node node, int depth) {
        for (int i = 1; i < depth; i++)
            System.out.print("\t");
        System.out.println(node.getNodeType() + "F" + node.getNodeName() + ":"
                + node.getNodeValue());
    }
}