package chapter07;

import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class MyNamespace04 {

	public static void main(String[] args) {
		try {
			DocumentBuilderFactory docfactory = DocumentBuilderFactory
					.newInstance();
			docfactory.setNamespaceAware(true);
			DocumentBuilder docbuilder = docfactory.newDocumentBuilder();
			Document document = docbuilder.parse("namespace04.xml");

			Element docElement = document.getDocumentElement();

			Attr attr = document.createAttributeNS("http://example.com",
					"ns1:attr");
			attr.setValue("a1");
			docElement.setAttributeNodeNS(attr);

			saveXML(document, System.out);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static void saveXML(Node node, OutputStream out) throws Exception {
		TransformerFactory tff = TransformerFactory.newInstance();
		Transformer tf = tff.newTransformer();

		DOMSource domsrc = new DOMSource();
		domsrc.setNode(node);

		StreamResult sr = new StreamResult(out);

		tf.transform(domsrc, sr);
	}
}