package chapter07;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class MyTraceDocument01 {

	public static void main(String[] args) {
		try {
			DocumentBuilderFactory docfactory = DocumentBuilderFactory
					.newInstance();
			docfactory.setValidating(true);
			docfactory.setIgnoringElementContentWhitespace(true);
			DocumentBuilder docbuilder = docfactory.newDocumentBuilder();
			Document document = docbuilder.parse("traceDocument01.xml");

			Node docElement = document.getDocumentElement();

			getAllNode(document, 0);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static void getAllNode(Node node, int depth) {
		depth++;
		printNode(node, depth);

		if (node.getNodeType() == Node.ELEMENT_NODE) {
			NamedNodeMap nnm = node.getAttributes();
			for (int i = 0; i < nnm.getLength(); i++) {
				printNode(nnm.item(i), depth);
			}
		}

		NodeList nl = node.getChildNodes();
		for (int i = 0; i < nl.getLength(); i++) {
			Node childnode = nl.item(i);
			getAllNode(childnode, depth);
		}
	}

	public static void printNode(Node node, int depth) {
		for (int i = 1; i < depth; i++)
			System.out.print("\t");
		System.out.println(node.getNodeType() + "F" + node.getNodeName() + ":"
				+ node.getNodeValue());
	}
}